using e_suite.UnitTestCore;
using eSuite.API.Controllers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Moq;
using System.Security.Claims;
using e_suite.API.Common;


namespace eSuite.API.UnitTests.Controllers.SequenceManagerControllerUnitTests;

public abstract class SequenceControllerBaseTest : TestBase
{
    protected Mock<ISequenceManager> _sequenceManagerMock = null!;
    protected SequencesController _sequenceController = null!;

    public override async Task Setup()
    {
        await base.Setup();
        _sequenceManagerMock = new Mock<ISequenceManager>();
        _sequenceController = new SequencesController(_sequenceManagerMock.Object);

        const long id = -1;
        const string email = "email@mail.test";
        const string displayName = "Test Test";

        AddAuthorisedUserToController(id, email, displayName);
    }
    protected void AddAuthorisedUserToController(long id, string email, string displayName)
    {
        var user = new ClaimsPrincipal(new ClaimsIdentity(new Claim[]
        {
            new(ClaimTypes.PrimarySid, id.ToString()),
            new(ClaimTypes.Email, email),
            new(ClaimTypes.Name, displayName)
            // other required and custom claims
        }, "TestAuthentication"));

        _sequenceController.ControllerContext = new ControllerContext
        {
            HttpContext = new DefaultHttpContext { User = user }
        };
    }
}